/*
 *	main.c
 *
 *	SPC Player V2
 *
 *	* Sun Oct 17 00:00:00 JST 2004 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
#define QUICK_REPEAT_DELAY	SEC(0.25)

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

typedef struct _SPCFILE {
	char fname[MAXFILENAME + 1];		/* t@C */
	int size;				/* t@CTCY */
} SPCFILE;

#define MAX_DISP	13			/* Sɕ\łt@C */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int draw;				/* ĕ`tO */
int now;				/* O[o^C} */
int joy;				/* pbh */

SPCFILE spc_file[MAXDIR];		/* SPCt@CXg */
int spc_count;				/* SPCt@C̐   */
int cursel;				/* ݂̑It@CCfNX */
int curtop;				/* ŏi\t@CCfNX */
int curplay = -1;			/* Đt@CCfNX */

const SPC2HDR* spc_hdr;			/* SPCt@C(curplay!=-1̎̂ݗL) */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void err_disp(const char* fmt, ...);
void app_init();
void app_exit();
void schedule();
void run();
int do_play(const char* fname);

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	run();

	return 0;
}

/****************************************************************************
 *	err_disp
 ****************************************************************************/

void
err_disp(const char* fmt, ...)
{
	int len, x, y;
	char str[100]; /* ꂮ炢Ώ[H */
	va_list ap;

	va_start(ap, fmt);
	len = vsprintf(str, fmt, ap);
	va_end(ap);

	x = (DISP_X - 5 * len) / 2;
	y = (DISP_Y - 10) / 2;
	memset(vbuff, 0, sizeof vbuff);
	render_string(&render, x, y, str, 0x80, 3);
	draw = 1;
	for(;;) {
		schedule();
		if(joy & (TRG_A | TRG_B | TRG_START | TRG_SELECT)) break;
	}
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

static int
spc_file_compare(const void* _a, const void* _b)
{
	SPCFILE* a = (SPCFILE*)_a;
	SPCFILE* b = (SPCFILE*)_b;
	return strcmp(a->fname, b->fname);
}

void
app_init()
{
	int retval, len;
	FILEINFO fi;
	SPCFILE* sf;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init_2d(&render, &surface, 0, 0, 0, 0);

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* SPCt@CT܂B */
	memset(spc_file, 0, sizeof spc_file);
	spc_count = 0;
	sf = &spc_file[0];
	retval = pceFileFindOpen(&fi);
	if(retval != 0) DIE();
	while(spc_count < MAXDIR) {
		retval = pceFileFindNext(&fi);
		if(!retval) break; /* t@CȂ */
		/* gq".spc"̃t@Ĉ݊i[܂B */
		len = strlen(fi.filename);
		if(len < 4) continue;
		if(strcasecmp(&fi.filename[len - 4], ".spc") == 0) {
			/* t@CƃTCYi[܂B */
			if(len > MAXFILENAME) DIE();
			memcpy(sf->fname, fi.filename, len);
			sf->size = fi.length;
			spc_count++;
			sf++;
		}
	}
	pceFileFindClose(&fi);
	if(spc_count == 0) {
		err_disp("SPCt@C܂");
		exit(0);
	}

	/* t@CɃ\[gB */
	qsort(spc_file, spc_count, sizeof(SPCFILE), spc_file_compare);

	/* 48MHz/1WAIT[hB */
	turbo(7);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#ifdef QUICK_REPEAT
	static unsigned char rep[8]; /* I[gs[gJE^ */
#endif /*QUICK_REPEAT*/

	int x, y;

	/* ɃX^oCɗȂ悤ɁB */
	pceAppActiveResponse(AAR_ACTIVE);

	/* drcʕ\XV̂߁AʍXVvȂĂAb1͋ʍXVB */
	if(now % SEC(1) == 0) {
		draw = 1;
	}

	/* ʍXVB */
	if(draw) {
		pceLCDTrans();
		draw = 0;
	}

	/* VXeB */
	yield();

	/* pbhԍXVB */
	joy = pcePadGet();

	/* O[o^C}XVB */
	now++;

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	for(x = 0; x < 8; x++) {
		y = 1 << x; /* PAD_* */
		if(QUICK_REPEAT_PADS & y) {
			if(joy & y) {
				if(rep[x] != 0xff) rep[x]++;
				if(rep[x] >= QUICK_REPEAT_DELAY) joy |= y << 8; /* TRG_* */
			} else {
				rep[x] = 0;
			}
		}
	}
#endif QUICK_REPEAT
}

/****************************************************************************
 *	run
 ****************************************************************************/

void
run()
{
	int retval, i, x, y, c, i_spc;
	SPCFILE* sf;

	goto L10; /* ͋` */
	for(;;) {
		schedule();

		/* pbh͂Ȃ΁A܂B */
		if(!joy) continue;

		/* IH */
		if(joy & TRG_SELECT) {
			exit(0);
		}

		/* t@CIύXH */
		if(curplay == -1) { /* ~̂ */
			if(joy & TRG_UP && cursel > 0            ) cursel--;
			if(joy & TRG_DN && cursel < spc_count - 1) cursel++;
			if(joy & TRG_LF) {
				cursel -= MAX_DISP;
				if(cursel < 0) cursel = 0;
			}
			if(joy & TRG_RI) {
				cursel += MAX_DISP;
				if(cursel > spc_count - 1) cursel = spc_count - 1;
			}
			if(cursel < curtop                 ) curtop = cursel                 ;
			if(cursel > curtop + (MAX_DISP - 1)) curtop = cursel - (MAX_DISP - 1);
		}

		/* ĐJnH */
		if(joy & TRG_A) {
			sf = &spc_file[cursel];
			retval = do_play(sf->fname);
			if(retval == 0) {
				curplay = cursel;
			} else {
				curplay = -1;
				err_disp("Đł܂ł");
				/* p */
			}
		}

		/* Đ~H */
		if(joy & TRG_B) {
			spc2_stop();
			curplay = -1;
		}

L10:
		/* t@CXg\B */
		memset(vbuff, 0, sizeof vbuff);
		sf = &spc_file[curtop];
		y = 8;
		for(i = 0; i < MAX_DISP + 1/*ɏ镪`*/; i++) {
			i_spc = curtop + i;
			if(i_spc > spc_count - 1) break;
			if(i_spc == cursel) {
				if(i_spc == curplay) {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 1);
					c = 3;
				} else {
					render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 + 1, 2);
					c = 0;
				}
			} else {
				if(i_spc == curplay) {
					c = 3;
				} else {
					c = 2;
				}
			}
			render_string(&render, 4 + 4 *  1, y, sf->fname, 0x82, c);
			render_printf(&render, 4 + 4 * 15, y, 0x82, c, "%8d bytes", sf->size);
			sf++;
			y += 6;
		}

		/* ^Cg\Biɂ͂ݏot@CXgɏ㏑j */
		render_rectangle_fill(&render, 0, 0, DISP_X, 6 + 1, 3);
		render_string(&render, 0, 1,
		//       0123456789012345678901234567890123
			"=========== SPC Player ===========",
			0x82, 0);
		if(curplay != -1) { /* tȂSPCt@C\ */
			x = 0;
			y = 8 + 10;
			render_rectangle_fill(&render, 0, y - 1, DISP_X, 6 * 10 + 1, 3);
			render_printf(&render, x +  4, y, 0x82, 0, "Song Title:"		); y += 6;
			render_printf(&render, x +  8, y, 0x82, 1, spc_hdr->id666.txt.song_title); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Game Title:"		); y += 6;
			render_printf(&render, x +  8, y, 0x82, 1, spc_hdr->id666.txt.game_title); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Dumper:"			); y += 6;
			render_printf(&render, x +  8, y, 0x82, 1, spc_hdr->id666.txt.dumper	); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Comments:"			); y += 6;
			render_printf(&render, x +  8, y, 0x82, 1, spc_hdr->id666.txt.comments	); y += 6;
			render_printf(&render, x +  4, y, 0x82, 0, "Date:"			); y += 6;
			render_printf(&render, x +  8, y, 0x82, 1, spc_hdr->id666.txt.date	); y += 6;
		}

		/* ʓ]B */
		draw = 1;
	}
}

/****************************************************************************
 *	do_play
 ****************************************************************************/

int
do_play(const char* fname)
{
	/* ܂Amɒ~܂B */
	spc2_stop();

	/* SPCt@C̃AhX擾܂B */
	spc_hdr = mmap(fname, NULL, 1/*DEFRAG*/);
	if(!spc_hdr) return -1;

	/* ĐJnB */
	return spc2_play(spc_hdr);
}

